﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Reg
{
    public partial class Form1 : Form
    {
        static int n = 10;
        int k = 0;
        double b;
        double a;

        public Form1()
        {
            InitializeComponent();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        //İLERLE
        private void button1_Click(object sender, EventArgs e)
        {
            n = Convert.ToInt32(comboBox1.Text);
            comboBox1.Enabled = false;
            groupBox2.Enabled = true;
            button2.Enabled = false;
            textBox1.Select();
        }

        //EKLE
        private void button2_Click(object sender, EventArgs e)
        {
            if (k < n)
            {
                listBox1.Items.Add(textBox1.Text);
                k++;
                label2.Text = (k+1).ToString() + ". Dönemin Satışı:";
                textBox1.Clear();
                button2.Enabled = false;
                textBox1.Select();
            }
            if (k == n)
            {
                label2.Enabled = false;
                button2.Enabled = false;
                textBox1.Enabled = false;
                groupBox2.Enabled = true;
                groupBox3.Enabled = true;
            }

        }
        //SIFIRLA
        private void button3_Click(object sender, EventArgs e)
        {
            comboBox1.Enabled = true;
            comboBox1.Text = "1";
            label2.Enabled = true;
            label2.Text = "1. Dönemin Satışı:";
            button2.Enabled = false;
            textBox1.Enabled = true;
            listBox1.Items.Clear();
            k = 0;
            n = Convert.ToInt32(comboBox1.Text);
            groupBox2.Enabled = false;
            groupBox3.Enabled = false;
            groupBox4.Enabled = false;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if(textBox1.Text != "")
            {
                button2.Enabled = true;
            }
        }

        //Hesapla
        private void button4_Click(object sender, EventArgs e)
        {
            double[] Y = new double[n];
            double[] X = new double[n];

            for (int i = 0; i < n; i++)
            {
                Y[i] = Convert.ToDouble(listBox1.Items[i]);
                X[i] = i + 1;
            }

            double XToplam = 0;
            double YToplam = 0;
            double XKareToplam = 0;
            double XYToplam = 0;

            for (int i = 0; i < n; i++)
            {
                XToplam += X[i];
                YToplam += Y[i];
                XKareToplam += X[i] * X[i];
                XYToplam += X[i] * Y[i];
            }
            b = (n * XYToplam - (XToplam * YToplam)) / (n * XKareToplam - XToplam * XToplam);
            a = (YToplam - b * XToplam) / n;

            label6.Text = Math.Round(a, 4).ToString();
            label7.Text = Math.Round(b, 4).ToString();
            label3.Text = "y = " + Math.Round(a, 4).ToString() + " + " + Math.Round(b, 4).ToString() + " x";
            //sapmayı hesapla
            double[] tahmin = new double[n];

            double y;
            for (int i = 0; i < n; i++)
            {
                y = a + b * (i + 1);
                tahmin[i] = y;
            }

            double sapma = 0;
            for (int i = 0; i < n; i++)
            {
                sapma += Math.Abs(Y[i] - tahmin[i]);
            }
            label11.Text = Math.Round(sapma, 4).ToString();
            label13.Text = Math.Round(a+b*(n+1), 4).ToString();
            groupBox4.Enabled = true;
        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        //TAHMİN YAP
        private void button5_Click(object sender, EventArgs e)
        {
            int x = Convert.ToInt32(textBox2.Text);
            double y = a + b * x;
            label10.Text = Math.Round(y, 2).ToString(); 
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            if (textBox2.Text != "")
            {
                button5.Enabled = true;
            }
            else
            {
                button5.Enabled = false;
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            groupBox3.Enabled = true;
        }

    }
}
